import java.util.Map;
import peasy.*;
PeasyCam cam;

ArrayList<Node> nodes = new ArrayList<Node>();
ArrayList<Arc> arcs = new ArrayList<Arc>();
Map<String, Integer> word2id = new HashMap<String, Integer>();
Table wordTable;
int numberOfNodes;
color red;
color blue;
color gray;

void initialize(){
  numberOfNodes = 40;
  makeNodes();
  makeArcs(0);
  colorizeFirstNodes(0);
}

void makeNodes(){
  int idx = 0;
  for (int dewey=0; dewey<10; dewey ++){
    wordTable = loadTable(Integer.toString(dewey)+".csv");
    for (int i = 0; i < wordTable.getRowCount() & i <numberOfNodes; i++){      
      String word = wordTable.getString(i, 3);    
      if (word2id.containsKey(word) == false){
        word2id.put(word, idx);
        nodes.add(new Node(word));
        idx += 1;
      }
    }
  }
}

void colorizeFirstNodes(int dewey){
  for (Node node : nodes) node.col = gray;
  wordTable = loadTable(Integer.toString(dewey)+".csv");
  nodes.get(word2id.get(wordTable.getString(0, 3))).col=red;
  nodes.get(word2id.get(wordTable.getString(1, 3))).col=red;  
}

void makeArcs(int dewey){       
    arcs = new ArrayList<Arc>();
    wordTable = loadTable(Integer.toString(dewey)+".csv");    
     for (int i = 2; i < wordTable.getRowCount() & i <numberOfNodes; i++){
           String parent = wordTable.getString(i, 1);
           String word = wordTable.getString(i, 3);      
           nodes.get(word2id.get(parent)).showWord = true;
           nodes.get(word2id.get(word)).showWord = true;   
           arcs.add(new Arc(nodes.get(word2id.get(parent)), nodes.get(word2id.get(word))));
     }
    
}

 void setup() {   
   size(1280, 800, P3D);
   //fullScreen(P3D, 0);   
   surface.setResizable(true);
   cam = new PeasyCam(this, 800);
   red = color(255, 0, 0, 255);
   blue = color(0,0,255, 255);
   gray = color(200, 200, 200, 255);
   initialize();     
 }
 
 void startTimer(){
   System.currentTimeMillis();
 }
 
 void resetDewey(int dewey){
   for (Node node: nodes) node.centralize();
   for (Node node: nodes) node.showWord = false;
   makeArcs(dewey);
   colorizeFirstNodes(dewey);
 }
 
 
 int counter = 0;
 int dewey = 1;
 void draw() {
     counter +=1;
     if (counter > 2000){       
        resetDewey(dewey);
        dewey +=1;
        if (dewey > 9) dewey = 0;
        counter =0;
     }
     cam.setYawRotationMode();   // like spinning a globe
     cam.rotateY(-0.005);
     background(50);
     lights();
     for (Node node:  nodes) node.update();     
     stroke(150, 100); 
     for (Arc arc:  arcs) arc.update();  
     
     
}