class Arc {
  Node node1;
  Node node2;
  float length;
  float markerCounter;
  float markerAccel;
  PVector vector;
  PVector force;
  PVector dot;
    
  Arc(Node _node1, Node _node2){
    node1 = _node1;
    node2 = _node2;
    markerCounter = 1;
    markerAccel = random(1.032,1.08);
  }

  void updateVector(){
    vector = PVector.sub(node1.position, node2.position);
    length = vector.mag();
  }
  
  void display(){
    drawMarker();
    drawLine();    
  }
  
  void drawLine(){
    stroke(150, 100);
    line(node1.position.x, node1.position.y, node1.position.z, node2.position.x, node2.position.y, node2.position.z);
  }
  
  void drawMarker(){
    noStroke();
    pushMatrix();
      dot = vector;
      dot.mult((markerCounter-1)*0.05);
      translate(node1.position.x - dot.x, node1.position.y-dot.y, node1.position.z-dot.z);      
      sphere(2);
     popMatrix();
     markerCounter *= markerAccel;     
     if (markerCounter >20) markerCounter=1;    
  }
  
  void applyForce(){    
    force = vector;
    force.mult(0.001);
    node2.applyExternalForce(force);
    node1.applyExternalForce(force.mult(-1));      
  };
      
  void update(){
    updateVector();
    display();    
    applyForce();    
  }
  
}