  class Node {
    PVector position;
    PVector velocity;   
    String word;      
    int repulsionFactor = 100;
    int size = 5;
    color col;
    boolean showWord;
  
    Node(String _word) {      
      word = _word;
      position = PVector.random3D().setMag(random(0,60));
      velocity = PVector.random3D().setMag(random(0,0.3));     
      col = color(250,255,255,200);
      showWord = false;      
   }
  
   void applyExternalForce(PVector externalForce) {        
        velocity.add(externalForce);
   }   
   
   void centralize(){
     velocity  = PVector.mult(position, -0.09);
     //cent.normalize().mult(100);
     //velocity.add(cent);
   }
   
   void applyRepulsion() {     
     float distanceSq;
     PVector repulsionVector;
     for(Node other_node:  nodes) {         
         repulsionVector = PVector.sub(other_node.position, position);
         distanceSq = repulsionVector.magSq();
         if (distanceSq > 1){           
           applyExternalForce(repulsionVector.normalize().mult(-repulsionFactor/distanceSq))  ;
         }
       }
     }   
     
   void applyFriction(){
     velocity.mult(0.95);     
   }  
   
   void writeLabel(){
     fill(255,200);
     textSize(20);   
     pushMatrix();
       float[] rotations = cam.getRotations();
       rotateX(rotations[0]);
       rotateY(rotations[1]);
       rotateZ(rotations[2]);       
       text(word, 9, 6);
     popMatrix();
   }
   
   void display() {
     pushMatrix();
       translate(position.x, position.y, position.z);
       noStroke();
       fill(col);
       sphere(size);
       if (showWord ==true) writeLabel();
     popMatrix();
   }   
   
   void update(){     
     applyRepulsion();
     applyFriction();
     position.add(velocity);
     display();
   }
}